<?php

class RedisSSICache implements DrupalCacheInterface {
  function __construct($bin) {
  }
  function set($cid, $data, $expire = CACHE_PERMANENT) {
    list($hash, $ssi_key) = explode(':', $cid, 2);
    $markup = $data['#markup'];
    $redis_key = $ssi_key;
    if ($hash == 'node') {
      if ($ssi_key[0] == '!') {
        // We are in the middle of a multiple view. Remove the markup,
        // the SSI command will be a multiple GET at the last node.
        $data['#markup'] = '';
        // Remove !:
        $redis_key = substr($ssi_key, 2);
      }
      else {
        // We only need to save the last node to redis but we need to
        // use the full key in the SSI command -- this is why we have a
        // separate $ssi_key and $redis_key.
        $ssi_keys = explode('/', $ssi_key);
        $redis_key = array_pop($ssi_keys);
      }
    }
    redis_ssi_client()->hset($hash, str_replace(array('&', '?'), ':', $redis_key), $markup);
    if ($data['#markup']) {
      $redis_nginx_path = variable_get('redis_ssi_nginx_path', '/redis');
      $data['#markup'] = "<!--# include virtual=\"$redis_nginx_path/$hash/$ssi_key\" -->";
    }
  }
  function get($cid) {
    return FALSE;
  }
  function getMultiple(&$cids) {
    return array();
  }
  function clear($cid = NULL, $wildcard = FALSE) {
  }
  function isEmpty() {
    return TRUE;
  }
}
